//<html><pre>
/* ----------------------------------------------------------------------------------------------
    jisx0208.java	ihrR[h							ver. 2.00 (JDK 1.02)  
    															ueyama@infonet.co.jp  1998.10.03
    															update: 2007.06.26
---------------------------------------------------------------------------------------------- */

import java.applet.Applet;
import java.awt.*;
import java.lang.Math;
import java.util.*;


public class jisx0208 extends Applet implements Runnable
{
	int			Ph	=20;
	int			Ofsx= 40,	Ofsy= 40;								// R[h\̍W
	int			Cx  =320,	Cy  =320;								// R[h\TCY
	int			Mx  = 99,	My  = 99;								// R[h\̃}EXNbNl (0 ` 15)
	int			Dx	=  0,	Dy	=  0;								// }EXhbOl
	int			Dx0	=385,	Dy0	= 91;								// R[h\GA̍W
	int			Bx[]={465, 465, 436, 494, 370, 465};				// {^\ XW  0: 1: 2: 3:
	int			By[]={287, 338, 313, 313, 338, 313};				// {^\ YW  4: Clr  5: Run/Stop
	int			Wait=1024;
	Image		Tbl, Img;
	Thread		th=null;
	boolean		Run=false;
	boolean		Mov=false;											// true: 胂[h
	int			Dir=0;												// 0:  1:  2:  3:
	Graphics	gx,gr;
	
	public void start()
	{
		if(th==null)
		{
			th=new Thread(this);
			th.start();
		}
	}
	
	public void update(Graphics g)
	{
		paint(g);
	}
	
	public void init()
	{
		String bg=getParameter("BgColor");
		int c=Integer.valueOf(bg,16).intValue();
		setBackground(new Color(c)); 
		gr=getGraphics();
		
		MediaTracker mt=new MediaTracker(this);
		Tbl=getImage(getCodeBase(), getParameter("figure0"));
		mt.addImage(Tbl, 0);
		Img=getImage(getCodeBase(), getParameter("figure1"));
		mt.addImage(Img, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
	}
	
	public boolean inside(int n, int a, int b)
	{
		return (n<=Math.max(a,b) && n>=Math.min(a,b)) ? true:false;
	}
	
	public void dsp_b(int x, int y, int f, int v, int c)			// {^̕\
	{
		int ox=0, oy=0, w=0, h=0;
		switch(c)
		{
			case 0:	w= 13; h= 14; ox=  0; oy=  0; 	break;			// 16i
			case 1:	w= 11; h= 14; ox=208; oy=  0; 	break;			// 2i  ()
			case 2:	w= 65; h= 14; ox=202; oy= 14; 	break;			// "CODE="
			case 3: w= 26; h= 23; ox=202; oy= 28; 	break;			// {^
			case 4: w= 15; h= 94; ox=280; oy=  0; 	break;			// "PoCg"
			case 5: w= 94; h= 15; ox=202; oy=189; 	break;			// "QoCg"
			case 6: w=202; h=199; ox=  0; oy= 14; 	break;			// R[h\}
		}
		gx=gr.create();
		gx.clipRect(x,y,w,h);
		gx.drawImage(Img,x-(ox+f*w),y-(oy+v*h),this);
		gx.dispose();
	}
	
	public void dsp_tbl(int x, int y, int f, int v, int c)			// R[h\̕\
	{
		int ox=0, oy=0, w=0, h=0;
		switch(c)
		{
			case 0:	w=321; h=321; ox= 20; oy= 20; 	break;			// R[h\̕\
			case 1:	w=321; h= 21; ox= 20; oy=  0; 	break;			// 㕔o̕\
			case 2:	w= 21; h=321; ox=  0; oy= 20; 	break;			// o̕\
		}
		gx=gr.create();
		gx.clipRect(x,y,w,h);
		gx.drawImage(Tbl,x-(ox+f*Ph),y-(oy+v*Ph),this);
		gx.dispose();
	}

	public void dsp_code(int x, int y, boolean b)					// R[h̕\
	{
		int i;
		String	bin,bx,by, hex;
		gr.clearRect(0,size().width-213,360,30);
		dsp_b(24,374,0,0,2);										// "CODE=" ̕\
		hex=Integer.toString(y+33+Dy,16)+Integer.toString(x+33+Dx,16);	// 16i
		for(i=3; i>=0; i--) dsp_b(94+13*i,374,Integer.parseInt(hex.substring(i,i+1),16),0,0);	// 16i̕\
		if(b)														// R[hQiŕ\
		{
			bx=Integer.toString(x+33+Dx,2);							// R[h̕\
			by=Integer.toString(y+33+Dy,2);
			for(i=bx.length(); i<8; i++) bx="0"+bx;					// ʂ 0 ĂŴQi
			for(i=by.length(); i<8; i++) by="0"+by;
			bin="2"+by+"4"+bx+"3";									// JbRi2,3jXy[Xi4j
			for(i=18;i>=0;i--) dsp_b(150+11*i,374,Integer.parseInt(bin.substring(i,i+1)),0,1);	// Qi̕\
		}
	}

	public void paint(Graphics g)
	{
		int		i, j, m=0;

		if(Run)
		{
			g.clearRect(0,0,size().width-213,size().height);		// R[h\̃NA
			g.clearRect(Dx0,Dy0,186,186);
		}
		else
		{
			g.clearRect(0,0,size().width,size().height);
			for(i=0; i<6; i++)										// {^̕\
			{
				if(i==0 && Dy==0 || i==1 && Dy==78 || i==2 && Dx==0 || i==3 && Dx==78 || i==4 && Mx==99) m=2;
				else m=0;
				j=(i==5 && Mov)?i+1:i;
				dsp_b(Bx[i], By[i], m,j,3);
			}
		}
		g.setColor(new Color(247,247,208));							// \̌o̐F
		g.fillRect(Ofsx,21,Cx,Ph);
		g.fillRect(21,Ofsy,Ph,Cy);
		if(Mx<16 && My<16)
		{
			g.setColor(new Color(240,240,192));						// NbNꂽsE̐F
			g.fillRect(Ofsx,Ofsy+My*Ph,Cx,Ph);
			g.fillRect(Ofsx+Mx*Ph,Ofsy,Ph,Cy);
			g.setColor(new Color(224,224,176));						// NbNꂽsĚo̐F
			g.fillRect(21,Ofsy+My*Ph,Ph,Ph);
			g.fillRect(Ofsx+Mx*Ph,21,Ph,Ph);
			g.setColor(new Color(208,208,144));						// NbNꂽsE̐F
			g.fillRect(Ofsx+Mx*Ph,Ofsy+My*Ph,Ph,Ph);
			dsp_code(Mx, My, true);
		}
		g.setColor(new Color(200,200,168));							// R[h\GA̕\
		g.fillRect(Dx0+Dx*2,Dy0+Dy*2,32,32);
		dsp_b(Ofsx-Ph*2+1,Ofsy, 0, 0, 4);							// uPoCgv̕\
		dsp_b(Ofsx,Ofsy-Ph*2+1, 0, 0, 5);							// uQoCgv̕\
		dsp_b(Dx0-14,Dy0-11, 0, 0, 6);								// R[h\}̕\
		dsp_tbl(Ofsx, Ofsy-Ph, Dx,  0, 1);							// 㕔o̕\
		dsp_tbl(Ofsx-Ph, Ofsy,  0, Dy, 2);							// o̕\
		dsp_tbl(Ofsx,    Ofsy, Dx, Dy, 0);							// R[h\iڍׁj̕\
	}
	
	public boolean area_chk(int n)
	{
		boolean f=true;
		if(n==0) Dy--; if(Dy<0) {Dy=0;  f=false;}
		if(n==1) Dy++; if(Dy>78){Dy=78; f=false;}
		if(n==2) Dx--; if(Dx<0) {Dx=0;  f=false;}
		if(n==3) Dx++; if(Dx>78){Dx=78; f=false;}
		return f;
	}

	public void run()
	{
		while(true)
		{
			if(Run)
			{
				Run=area_chk(Dir);
				repaint();
			}
			try
			{
				Thread.sleep(Wait);
			}
			catch (InterruptedException e){}
			Wait=64;
		}
	}
	
	public boolean mouseDown(Event e, int mx, int my)				// }EXNbN
	{
		int i;
		boolean f=true;
		if(inside(mx,Ofsx,Ofsx+Cx) && inside(my,Ofsy,Ofsy+Cy))		// R[h\NbN
		{
			Mx=(mx-Ofsx)/Ph;
			My=(my-Ofsy)/Ph;
			repaint();
		}
		if(inside(mx,Dx0,Dx0+188) && inside(my,Dy0,Dy0+188))		// R[h\GANbN
		{
			Dx=(mx-Dx0-16)/2; Dy=(my-Dy0-16)/2;
			area_chk(-1);
			repaint();
		}
		for(i=0; i<6; i++)
		{
			if(inside(mx,Bx[i],Bx[i]+26) && inside(my,By[i],By[i]+23))	// {^NbN
			{
				if(i<4)
				{
					f=area_chk(i);
					if(Mov) Run=true;
				}
				if(i==4 && Mx<16 && My<16) {Mx=99; My=99;} 			// Clr {^
				if(i==5) Mov=!Mov;									// Run/Stop {^
				if(f)
				{
					dsp_b(Bx[i],By[i], 1,(i==5 && !Mov)?i+1:i, 3);	// {^΂ŕ\
					Dir=i;
				}
			}
		}
		return true;
	}
	
	public boolean mouseDrag(Event e, int mx, int my)				// }EXhbO
	{
		if(inside(mx,Dx0,Dx0+188) && inside(my,Dy0,Dy0+188))
		{
			Dx=(mx-Dx0-16)/2; Dy=(my-Dy0-16)/2;
			area_chk(-1);
			repaint();
		}
		return true;
	}

	public boolean mouseMove(Event e, int mx, int my)				// }EXR[h\̒ňړ
	{
		if(inside(mx,Ofsx,Ofsx+Cx) && inside(my,Ofsy,Ofsy+Cy) && Mx==99 && My==99)
		{
			dsp_code((mx-Ofsx)/Ph, (my-Ofsy)/Ph, false);			// R[hi16ij\
		}
		return true;
	}
	
	public boolean mouseUp(Event e, int mx, int my)					// }EX̃NbN𗣂
	{
		if(Mov) Run=false;
		Wait=1024;
		repaint();
		return true;
	}
	
	public void stop()
	{
		if(th!=null)
		{
			th.stop();
			th=null;
		}
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</A></html>
